Subject: Re: Port numbers and IPv6

From: [email-masked] (Noel Chiappa)
Date: Fri, 15 Jul 2005 16:55:54 -0400 (EDT)

> From: Ned Freed <[email-masked]>

Let me make sure I understand you here:

    > IMAP4 has the characteristic that you often have a huge number of
    > incoming connections, only a few of which are active at any given time.
    > Designing servers to accomodate huge numbers of connections is a bit
    > tricky, but workable: ...
    > The 65536 limit, OTOH, has to be dealt with by using multiple server IP
    > addresses, which in turn usually require multiple interfaces ...
    > ... that doesn't mean nobody is hitting the 65536 limit imposed by
    > source port numbers. They are, it causes problems

You're saying that there are servers which have close to (or more) than 65K
connections to a *single client IP address* (i.e. it may be a NAT, with a
number of hosts behind it)? (If a server is talking to a number of different
client IP addresses, it can have up to 65K connections to *each*.)

	Noel

_______________________________________________
Ietf mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ietf

---

From: "Steven M. Bellovin" <[email-masked]>
Date: Fri, 15 Jul 2005 17:16:52 -0400

In message <[email-masked]>, Noel Chiappa writes
>client IP addresses, it can have up to 65K connections to *each*.)

Ned isn't the first person I've heard this observation from.  Yes, 
there are some really large-scale systems that run into this limit.

Sure, there are work-arounds, such as assigning multiple IP addresses 
to the server and using DNS-based load balancing.  That doesn't change 
the fact that the basic design has run afoul of an address space limit.

Circa 1974, in a computer architecture class, I heard Fred Brooks point
out that *every* successful computer design eventually ran out of address 
space.  The same applies to network protocols.

		--Steven M. Bellovin, http://www.cs.columbia.edu/~smb

---

From: Ned Freed <[email-masked]>
Date: Fri, 15 Jul 2005 14:17:39 -0700 (PDT)

> client IP addresses, it can have up to 65K connections to *each*.)

Yes, that is exactly what I am saying (now for the third time).

				Ned

---

From: "Stephen Sprunk" <[email-masked]>
Date: Fri, 15 Jul 2005 16:26:28 -0500

Thus spake "Noel Chiappa" <[email-masked]>
>    > IMAP4 has the characteristic that you often have a huge number
>    > of incoming connections, only a few of which are active at any
>    > given time.  Designing servers to accomodate huge numbers of
>    > connections is a bit tricky, but workable: ...
>    > The 65536 limit, OTOH, has to be dealt with by using multiple
>    > server IP addresses, which in turn usually require multiple
>    > interfaces ...
> You're saying that there are servers which have close to (or more)
> than 65K connections to a *single client IP address* (i.e. it may be a
> NAT, with a number of hosts behind it)? (If a server is talking to a
> number of different client IP addresses, it can have up to 65K
> connections to *each*.)

That assumes the client is directly talking to the IMAP server.  Some 
servers are behind an "SSL accelerator" such that all connections come from 
a single IP address, so only 64k clients are possible.  Other servers may be 
behind a webmail application, with the same effect.

The number of folks experiencing this has to be pretty low, but it'd be a 
severe problem for them.

S

Stephen Sprunk      "Those people who think they know everything
CCIE #3723         are a great annoyance to those of us who do."
K5SSS                                             --Isaac Asimov

---

From: Masataka Ohta <[email-masked]>
Date: Sat, 16 Jul 2005 08:15:05 +0900

> space.  The same applies to network protocols.

An interesting theory.

It explains why IPv6 can't be successful.

						Masataka Ohta

---

From: "Steven M. Bellovin" <[email-masked]>
Date: Fri, 15 Jul 2005 22:16:45 -0400

>It explains why IPv6 can't be successful.

Nice line.  I don't agree with either your conclusion or your 
sentiments, but it is definitely a nice line.

---

From: "JFC (Jefsey) Morfin" <[email-masked]>
Date: Sat, 16 Jul 2005 11:03:01 +0200

>sentiments, but it is definitely a nice line.

Has work been carried on IPv6 Interface ID Grids to give a quasi illimited 
number of pre-defined/agreed connection points/ports?
(my interest is more "plug and play" and access engine oriented than IPv6 
behind NAT or ... IPv8).
jfc